

!!! Listing 1

<?stylesheet href="liga.dsl" type="text/dsssl"?> 
<?xml version="1.0" standalone="yes" encoding="ISO-8859-1"?>
<!DOCTYPE liga [
  <!ELEMENT liga    (pos+)                 >
  <!ELEMENT pos     (verein, punkte, tore) >
  <!ELEMENT verein  (#PCDATA)              >
  <!ELEMENT punkte  (#PCDATA)              >
  <!ELEMENT tore    (#PCDATA)              >
]>

<liga>
  <pos>
    <verein>1. FC Kaiserslautern</verein>
    <punkte>45</punkte>
    <tore>+17</tore>
  </pos>
  <pos>
    <verein>B. Mnchen</verein>
    <punkte>41</punkte>
    <tore>+18</tore>
  </pos>
<!-- hier stehen noch mehr Vereine -->
  <pos>
    <verein>VfL Bochum</verein>
    <punkte>20</punkte>
    <tore>-9</tore>
  </pos>
  <pos>
    <verein>1. FC Kln</verein>
    <punkte>20</punkte>
    <tore>-13</tore>
  </pos>
</liga>
<!-- Beispiele aus Behme/Mintert "XML in der Praxis", Addison Wesley 1998 -->


!!! Listing 2

#!/bin/sh

# XML-Handler - Wrapper zur Umwandlung von XML in HTML mit XSL oder DSSSL

PATH=/usr/bin/:/pfad/zum/JDK/1.1.6/bin/:${PATH}
export PATH

# Konfiguration fuer Jade und XT
#
JADEBIN=/pfad/zu/jade/1.2.1/bin/jade
CATALOG=/pfad/zu/jade/1.2.1/dsssl/catalog
# Der gesamte CLASSPATH muss _eine_ Zeile sein...
CLASSPATH=/pfad/zu/xp/0.5:/pfad/zu/xp/0.5/xp.jar:
  /pfad/zu/xt/19990514/xt.jar:/pfad/zu/xt/19990514/sax.jar:
  /pfad/zu/jdk/1.1.6/lib/classes.zip:${CLASSPATH}
XTWRAPPER=/pfad/zu/xt/19990514/bin/xt
JDKHOME=/pfad/zu/jdk/1.1.6
JAVA_HOME=/pfad/zu/jdk/1.1.6
export CLASSPATH JDKHOME JAVA_HOME

# 1) Name der XML-Datei
#
XMLDATEI=${PATH_TRANSLATED}

# 2) Welchen MIME-Typ verwendet das zugehoerige StyleSheet 
#
StyleSheetMIME=`grep stylesheet ${XMLDATEI} | \
  sed 's/.*type="\([^\"]*\)".*/\1/'`

if [ "${StyleSheetMIME}" = "text/dsssl" ]
then
  # 3) Bei DSSSL-StyleSheets unmittelbar Jade aufrufen
  # HTTP-Header:
  #
  echo "Content-type: text/html"
  echo
  ${JADEBIN} -c ${CATALOG} -t sgml ${XMLDATEI}

  # abschliessendes LF, weil Jade es unterdrueckt
  echo
  exit

else if [ "${StyleSheetMIME}" = "text/xsl" ]
then
  # 4) Falls der Browser XSL beherrscht, keine Transformation
  #
  ACCEPT=`echo ${HTTP_ACCEPT} | sed 's|.*\(text/xsl\).*|\1|'`
  if [ "${ACCEPT}" = "text/xsl" ]
  then
    # HTTP-Header:
    #
    echo "Content-type: text/xml"
    echo
    cat ${XMLDATEI}

   else
     # HTTP-Header:
     #
     echo "Content-type: text/html"
     echo
     # 5) Transformieren: zuerst den Namen des XSL-StyleSheets ermitteln
     #
    
     XSLSS=`grep stylesheet ${XMLDATEI} | sed 's/.*href="\([^\"]*\)".*/\1/'`
     DIRECTORY=`echo ${XMLDATEI} | sed 's|^\(.*/\)[^/]*$|\1|'`
        
     cd ${DIRECTORY}
     ${XTWRAPPER} ${XMLDATEI} ${XSLSS} 
   fi
   exit
else
   echo "<h1>Interner Fehler</h1><h2>${StyleSheetMIME}"
   fi
fi

exit

!!! Listing 3

<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN">
(declare-flow-object-class element
  "UNREGISTERED::James Clark//Flow Object Class::element")

(element liga
  (make element gi: "table"
        attributes: (cons (list "border" "1") '())
        (make element gi: "tr"           ; Kopfzeile der Tabelle
              (make sequence
                (make element gi: "th" (literal "Mannschaft"))
                (make element gi: "th" (literal "Punkte"))
                (make element gi: "th" (literal "Tor-Verhltnis"))))
        (process-children)))             ; Inhalt der Tabelle

(element pos    (make element gi: "tr"))

(element verein (make element gi: "td"))

(element punkte (make element gi: "td"))

(element tore   (make element gi: "td"))

!!! Listing 4 ???

!!! Listing 5 ???


