#!/usr/bin/perl -w
##################################################
# HMAC MD5/SHA1 Message Digest
# 1999 mschilli@netscape.com
#    hmac.pl -sha1|-md5 key [file] ...
##################################################

use Digest::HMAC;
use Digest::SHA1;
use Digest::MD5;

$METHOD = shift if @ARGV && 
                   $ARGV[0] =~ /^-(md5|sha1)/;
usage("No method defined") unless defined $METHOD;
$METHOD = "Digest::" . uc(substr($METHOD, 1));

$KEY  = shift or usage("No key given");

$hmac = Digest::HMAC->new($KEY, $METHOD);
$hmac->add(join('', <>));
print $hmac->b64digest, "\n";

sub usage {
   print "@_\nusage: $0 -md5|-sha1 key [file] ...\n";
   exit 1;
}
